//********************************************************************
//*** t/test.t.cc
//*** Copyright (c) 2003-2008 by Markus Winand <mws@fatalmind.com>
//*** $Id: Test.t.cc,v 1.5.2.1 2008/04/13 11:56:51 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#include "t/main.hh"
#include <stdlib.h>

void INIT_test_selftest() {
}

void TEST_test_selftest_Memory() {
	fatalmind_trace_malloc = 1;
	try {
		for (int i = 0; i < 1000; ++i) {
			assertNotGrowing(i);
			if (i > 40) {
				malloc(4);
			}
		}
		assertNotReach();
	} catch (...) {
		// fine
	}

	// should not fire
	for (int i = 0; i < 1000; ++i) {
		assertNotGrowing(i);
		void *x = malloc(4);
		free(x);
		if (i == 10) {
			fatalmind_trace_malloc = 0;
		}
	}
}

void CLEANUP_test_selftest() {
}
